/*
Setup file for the main
*/

#ifndef SETUP_HPP//Header Guards Prevents Multiple includes
#define SETUP_HPP

//Libraries and header includes
#include "rtos.h"
#include "LED.hpp"
#include "SERIAL.hpp"
#include "TIME.hpp"
#include "SERIAL_COMMANDS.hpp"
#include "THREADS.hpp"
#include "LED_LOGGING.hpp"
#include "STEPPER_MOTOR.hpp"
#include "SPI.hpp"
#include "ALGORITHM.hpp"
#include <iostream>
#include <bitset>

using namespace std;
//Time definitions


LED Red_led(PE_15);
LED Green_led(PB_11);

//Forward Declarations of functions

void Serial_Comms();
void Console_Output_ISR();    
void Serial_Comms_Data_Get();
void Console_Output_ISR();
void Rotate_Steps();


//Sets up the sides of the cube
static SIDE SIDE1();
static SIDE SIDE2();
static SIDE SIDE3();
static SIDE SIDE4();
static SIDE SIDE5();
static SIDE SIDE6();


/*
0 White
1 Orange
2 Blue
3 Red
4 Green
5 Yellow
These are the faces of the cube then there are the 3x3 cubelets within each face
*/

#endif 